

   MEMBER('WEBORDER.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('WEBOR003.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEBOR005.INC'),ONCE        !Req'd for module callout resolution
                     END



BrowseProduct PROCEDURE                                    ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
FilesOpened          BYTE                                  !
BRW1::View:Browse    VIEW(Product)
                       PROJECT(PROD:ProdCode)
                       PROJECT(PROD:Description)
                       PROJECT(PROD:Price)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
PROD:ProdCode          LIKE(PROD:ProdCode)            !List box control field - type derived from field
PROD:Description       LIKE(PROD:Description)         !List box control field - type derived from field
PROD:Price             LIKE(PROD:Price)               !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the Product File'),AT(,,159,180),FONT('MS Sans Serif',8,COLOR:Black,),IMM,HLP('BrowseProduct'),SYSTEM,GRAY,RESIZE,MDI
                       LIST,AT(8,30,143,142),USE(?Browse:1),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('24R(2)|M~Code~C(0)@n05@80L(2)|M~Description~L(2)@s50@44D(12)|M~Unit price~C(0)@n' &|
   '10.2@'),FROM(Queue:Browse:1)
                       BUTTON('&Insert'),AT(8,140,45,14),USE(?Insert:2),HIDE
                       BUTTON('&Change'),AT(57,140,45,14),USE(?Change:2),HIDE,DEFAULT
                       BUTTON('&Delete'),AT(106,140,45,14),USE(?Delete:2),HIDE
                       SHEET,AT(4,4,151,172),USE(?CurrentTab)
                         TAB('By Product Code'),USE(?Tab:2)
                         END
                         TAB('By Product Description'),USE(?Tab:3)
                         END
                       END
                       BUTTON('Close'),AT(61,162,45,14),USE(?Close),HIDE
                       BUTTON('Help'),AT(110,162,45,14),USE(?Help),HIDE,STD(STD:Help)
                     END
WebWindow            CLASS(WebWindowClass)
                     END
IC:CurControl        &WebControlClass                      ! Temporary control pointer
IC:CurFrame          &WebFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED ! Method added to host embed code
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort0:StepClass StepLongClass                        ! Default Step Manager
BRW1::Sort1:StepClass StepStringClass                      ! Conditional Step Manager - CHOICE(?CurrentTab) = 2
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseProduct')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Product.Open                                      ! File Product used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Product,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  !- Initialise the internet classes
  WebWindow.Init(WebServer, HtmlManager, QuickWindow{PROP:text} & ' (BrowseProduct)')
  WebWindow.SetFormatOptions(2, 2, 6, 13)
  WebWindow.MenubarType = PROP:above
  WebWindow.CreateClose = CLOSE:Always
  WebWindow.SetPageBackground(12632256, 'Crumpled.gif')
  WebWindow.BorderWidth = 2
  WebWindow.SheetBorderWidth = 2
  WebWindow.OptionBorderWidth = 2
  WebWindow.GroupBorderWidth = 2
  WebWindow.CreateCaption = 1
  
  IC:CurControl &= WebWindow.AddControl(?Browse:1)
  IC:CurControl.SetQueue(Queue:Browse:1)
  
  IC:CurControl &= WebWindow.AddControl(?CurrentTab)
  IC:CurControl.SetEventAction(EVENT:Accepted, Update:Partial)
  IF (WebServer.Active)
    IC:CurFrame &= GetWebActiveFrame()
    IC:CurFrame.CopyControlsToWindow(WebWindow, TRUE, TRUE)
  END
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort1:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon PROD:Description for sort order 1
  BRW1.AddSortOrder(BRW1::Sort1:StepClass,PROD:ByDesc)     ! Add the sort order for PROD:ByDesc for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,PROD:Description,1,BRW1)       ! Initialize the browse locator using  using key: PROD:ByDesc , PROD:Description
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon PROD:ProdCode for sort order 2
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,PROD:ByCode)     ! Add the sort order for PROD:ByCode for sort order 2
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort0:Locator.Init(,PROD:ProdCode,1,BRW1)          ! Initialize the browse locator using  using key: PROD:ByCode , PROD:ProdCode
  BRW1.AddField(PROD:ProdCode,BRW1.Q.PROD:ProdCode)        ! Field PROD:ProdCode is a hot field or requires assignment from browse
  BRW1.AddField(PROD:Description,BRW1.Q.PROD:Description)  ! Field PROD:Description is a hot field or requires assignment from browse
  BRW1.AddField(PROD:Price,BRW1.Q.PROD:Price)              ! Field PROD:Price is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseProduct',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Product.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseProduct',QuickWindow)             ! Save window data to non-volatile store
  END
  WebWindow.Kill
  IF (WebServer.Active)
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateProduct
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    IF WebWindow.TakeEvent()
      BREAK
    END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window


