   PROGRAM


LinkBaseClasses      EQUATE(1)
BaseClassDllMode     EQUATE(0)

   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('ICTXTOUT.INC')
   INCLUDE('ICBROKER.INC')
   INCLUDE('ICWINDOW.INC')
   INCLUDE('ICCNTRLS.INC')
   INCLUDE('ICCLIENT.INC')
   INCLUDE('ICREPORT.INC')
   INCLUDE('ICSTD.EQU')

   MAP
     MODULE('Windows API')
SystemParametersInfo PROCEDURE (LONG uAction, LONG uParam, *? lpvParam, LONG fuWinIni),LONG,RAW,PROC,PASCAL,DLL(TRUE),NAME('SystemParametersInfoA')
     END
     MODULE('WEBORBC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('WEBOR001.CLW')
Main                   PROCEDURE   !C6 Wizard Application for C:\Clarion6\WEBTUTOR\Weborder.dct
     END
     INCLUDE('dde.clw')
     MODULE('')
       WebControlFactory(SIGNED),*WebControlClass
       GetWebActiveFrame(),*WebFrameClass
       SetWebActiveFrame(<*WebFrameClass>)
     END
     INCLUDE('ICSTD.INC')
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

Customer             FILE,DRIVER('TOPSPEED'),RECLAIM,NAME('CUSTOMER.TPS'),PRE(CUST),CREATE,BINDABLE
ByNumber                 KEY(CUST:CustNo),NOCASE,OPT,PRIMARY
ByName                   KEY(CUST:Name),DUP,NOCASE,OPT
Record                   RECORD,PRE()
CustNo                      LONG
Name                        STRING(30)
Address                     STRING(30)
City                        STRING(20)
State                       STRING(2)
Zip                         DECIMAL(5)
Phone                       DECIMAL(11)
Contact                     STRING(20)
                         END
                     END                       

Items                FILE,DRIVER('TOPSPEED'),RECLAIM,NAME('items.TPS'),PRE(ITEM),CREATE,BINDABLE
AsEntered                KEY(ITEM:CustNo,ITEM:OrderNo,ITEM:LineNo),NOCASE,OPT,PRIMARY
ByProduct                KEY(ITEM:ProdCode,ITEM:OrderNo,ITEM:LineNo),DUP,NOCASE,OPT
Record                   RECORD,PRE()
CustNo                      LONG
OrderNo                     LONG
LineNo                      SHORT
ProdCode                    SHORT
Quantity                    SHORT
Price                       DECIMAL(7,2)
Total                       DECIMAL(7,2)
                         END
                     END                       

Orders               FILE,DRIVER('TOPSPEED'),RECLAIM,NAME('orders.TPS'),PRE(ORD),CREATE,BINDABLE
ByCustomer               KEY(ORD:CustNo,ORD:OrderNo),DUP,NOCASE,OPT
Record                   RECORD,PRE()
CustNo                      LONG
OrderNo                     LONG
OrderDate                   LONG
Reference                   STRING(24)
ShipTo                      STRING(32)
ShipAddress                 STRING(32)
ShipCity                    STRING(22)
ShipState                   STRING(2)
ShipZip                     DECIMAL(5)
Shipped                     BYTE
Carrier                     STRING(1)
                         END
                     END                       

Product              FILE,DRIVER('TOPSPEED'),RECLAIM,NAME('product.TPS'),PRE(PROD),CREATE,BINDABLE
ByCode                   KEY(PROD:ProdCode),NOCASE,OPT,PRIMARY
ByDesc                   KEY(PROD:Description,PROD:ProdCode),DUP,NOCASE,OPT
Record                   RECORD,PRE()
ProdCode                    SHORT
Description                 STRING(50)
Price                       DECIMAL(7,2)
                         END
                     END                       

State                FILE,DRIVER('TOPSPEED'),RECLAIM,NAME('state.TPS'),PRE(ST),CREATE,BINDABLE
ByCode                   KEY(ST:StateCode),NOCASE,OPT
ByState                  KEY(ST:StateName),DUP,NOCASE,OPT
Record                   RECORD,PRE()
StateCode                   STRING(2)
StateName                   STRING(20)
                         END
                     END                       


Broker               BrokerClass
HtmlManager          HtmlClass
JavaEvents           JslEventsClass
WebServer            WebServerClass
WebFilesManager      WebFilesClass
ShutDownManager      CLASS(ShutDownClass)
Close                  PROCEDURE,VIRTUAL
                     END
ICServerWin          WINDOW,AT(-100,-100,0,0)
                     END
Access:Customer      &FileManager,THREAD                   ! FileManager for Customer
Relate:Customer      &RelationManager,THREAD               ! RelationManager for Customer
Access:Items         &FileManager,THREAD                   ! FileManager for Items
Relate:Items         &RelationManager,THREAD               ! RelationManager for Items
Access:Orders        &FileManager,THREAD                   ! FileManager for Orders
Relate:Orders        &RelationManager,THREAD               ! RelationManager for Orders
Access:Product       &FileManager,THREAD                   ! FileManager for Product
Relate:Product       &RelationManager,THREAD               ! RelationManager for Product
Access:State         &FileManager,THREAD                   ! FileManager for State
Relate:State         &RelationManager,THREAD               ! RelationManager for State

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

lCurrentFDSetting    LONG                                  ! Used by window frame dragging
lAdjFDSetting        LONG                                  ! ditto

  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('WEBORDER.INI', NVD_INI)                     ! Configure INIManager to use INI file
  DctInit
  SetWebActiveFrame
  WebFilesManager.Init(1, '')
  JavaEvents.Init
  Broker.Init('WEBORDER', WebFilesManager)
  HtmlManager.Init(WebFilesManager)
  WebServer.Init(Broker, ShutDownManager, '', 600, '', WebFilesManager)
  WebServer.SetDialogPageBackground(12632256, 'Crumpled.gif')
  IF (WebServer.GetInternetEnabled())
    WebServer.Connect
  END
  SystemParametersInfo (38, 0, lCurrentFDSetting, 0)       ! Configure frame dragging
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 0, lAdjFDSetting, 3)
  END
  Main
  INIMgr.Update
  WebServer.Halt
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 1, lAdjFDSetting, 3)
  END
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher
    
ShutDownManager.Close    PROCEDURE
  CODE

  WebServer.Kill
  HtmlManager.Kill
  Broker.Kill()
  JavaEvents.Kill
  WebFilesManager.Kill


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

