

   MEMBER('WebInv.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('WEBIN003.INC'),ONCE        !Local module procedure declarations
                     END


PrintSelectProduct PROCEDURE                               ! Generated from procedure template - Report

Progress:Thermometer BYTE                                  !
Process:View         VIEW(Products)
                       PROJECT(PRO:Cost)
                       PROJECT(PRO:Description)
                       PROJECT(PRO:Price)
                       PROJECT(PRO:ProductNumber)
                       PROJECT(PRO:ProductSKU)
                       PROJECT(PRO:QuantityInStock)
                       PROJECT(PRO:ReorderQuantity)
                     END
ProgressWindow       WINDOW('Report Products'),AT(,,142,59),FONT('MS Sans Serif',8,,FONT:regular),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(46,42,49,15),USE(?Progress:Cancel),FLAT,LEFT,MSG('Cancel Report'),TIP('Cancel Report'),ICON('WACANCEL.ICO')
                     END

Report               REPORT('Products Report'),AT(1000,1575,6500,8400),PAPER(PAPER:LETTER),PRE(RPT),FONT('MS Sans Serif',8,,FONT:regular),THOUS
                       HEADER,AT(1000,1000,6500,550),USE(?Header),FONT('MS Sans Serif',8,,FONT:regular)
                         STRING('Selected Product Report'),AT(17,58,6500,220),USE(?ReportTitle),CENTER,FONT('MS Sans Serif',11,,FONT:bold+FONT:underline)
                       END
Detail                 DETAIL,AT(,,6500,1875),USE(?Detail)
                         IMAGE,AT(4350,42,1408,1617),USE(?Image1)
                         STRING('Product SKU:'),AT(892,58,967,167),USE(?HeaderTitle:1),TRN
                         STRING(@s10),AT(1975,67,2258,167),USE(PRO:ProductSKU),LEFT
                         STRING('Description:'),AT(892,325,967,167),USE(?HeaderTitle:2),TRN
                         STRING(@s35),AT(1975,333,2367,167),USE(PRO:Description),LEFT
                         STRING('Price:'),AT(892,592,967,167),USE(?HeaderTitle:3),TRN
                         STRING(@n$10.2B),AT(1983,600,567,167),USE(PRO:Price),RIGHT(30)
                         STRING('Quantity In Stock:'),AT(900,858,967,167),USE(?HeaderTitle:4),TRN
                         STRING(@n-10.2),AT(1983,867,567,167),USE(PRO:QuantityInStock),RIGHT(30)
                         STRING('Reorder Quantity:'),AT(892,1125,967,167),USE(?HeaderTitle:5),TRN
                         STRING(@n9.2),AT(1983,1133,567,167),USE(PRO:ReorderQuantity),RIGHT(30)
                         STRING('Cost:'),AT(892,1417,967,167),USE(?HeaderTitle:6),TRN
                         STRING(@n$10.2B),AT(2017,1425,567,167),USE(PRO:Cost),RIGHT(30)
                       END
                     END
ThisWindow           CLASS(ReportManager)
AskPreview             PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

ProgressMgr          StepLongClass                         ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
? DEBUGHOOK(Products:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.AskPreview PROCEDURE

  CODE
  IF (WebServer.IsEnabled())
    ENDPAGE(SELF.Report)
    WebPreview(WebServer,SELF.PreviewQueue,'',0,0)
    RETURN
  END
  PARENT.AskPreview


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('PrintSelectProduct')
  WebFilesManager.SelectTarget(Secure:None)
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Products.Open                                     ! File Products used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{Prop:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Products, ?Progress:PctText, Progress:Thermometer, ProgressMgr, PRO:ProductNumber)
  ThisReport.AddSortOrder(PRO:KeyProductNumber)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Products.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  Previewer.Maximize=True
  IF SELF.OriginalRequest = ProcessRecord
    CLEAR(SELF.DeferWindow,1)
    ThisReport.AddRange(PRO:ProductNumber)        ! Overrides any previous range
  END
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Products.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  Report$?Image1{Prop:Text} = PRO:PictureFile
  PRINT(RPT:Detail)
  RETURN ReturnValue

